<?php
/*
Plugin Name:Lsansan sitemap
Description: 这是一个用于生成网站sitemap文件的插件，功能简单，快捷好用。该插件偏向定制化，支持自定义文章类型、自定义分类等等
Author: it放牛娃
Author URI: https://blog.luojiasan.com
Version: 1.1.3
*/

define('NEW_BAIDU_SITEMAP_OPTION','new_baidu_sitemapoption');
require_once("lsansan_function.php");
date_default_timezone_set("Asia/Shanghai");

function get_baidu_sitemap_options(){
	$array_baidu_sitemap_options = array();
	$get_baidu_sitemap_options = get_option(NEW_BAIDU_SITEMAP_OPTION);
	if($get_baidu_sitemap_options){
		list(
			$array_baidu_sitemap_options['it_is_Enabled_XML_Sitemap'],
			$array_baidu_sitemap_options['it_is_Enabled_Html_Sitemap'],
			$array_baidu_sitemap_options['it_is_Enabled_TXT_Sitemap'],
			$array_baidu_sitemap_options['it_is_update_sitemap_when_post'],
			$array_baidu_sitemap_options['it_post_limit'],
			$array_baidu_sitemap_options['it_post_select'],
			$array_baidu_sitemap_options['it_page_select'],
			$array_baidu_sitemap_options['it_category_select'],
			$array_baidu_sitemap_options['it_tag_select'],
			$array_baidu_sitemap_options['it_custom_post_select'],
			$array_baidu_sitemap_options['it_custom_category_select'],
			$array_baidu_sitemap_options['it_custom_post_noselect'],
			$array_baidu_sitemap_options['it_custom_archives_select'],
			$array_baidu_sitemap_options['it_custom_archives_select0'],
			$array_baidu_sitemap_options['it_custom_archives_name_select'],
			$array_baidu_sitemap_options['it_custom_archives_name_select0'],
			$array_baidu_sitemap_options['it_custom_baidu_sutmit_token'],
			$array_baidu_sitemap_options['it_custom_baidu_sutmit_token_auto'],
			$array_baidu_sitemap_options['it_custom_baidu_sutmit_token_post_auto'],
			$array_baidu_sitemap_options['it_custom_baidu_sutmit_log'],
			
		) = explode("|",$get_baidu_sitemap_options);
	}else{
		if(!$array_baidu_sitemap_options['it_is_Enabled_XML_Sitemap']){$array_baidu_sitemap_options['it_is_Enabled_XML_Sitemap'] = '1';}
		if(!$array_baidu_sitemap_options['it_is_Enabled_Html_Sitemap']){$array_baidu_sitemap_options['it_is_Enabled_Html_Sitemap'] = '1';}
		if(!$array_baidu_sitemap_options['it_is_Enabled_TXT_Sitemap']){$array_baidu_sitemap_options['it_is_Enabled_TXT_Sitemap'] = '1';}
		if(!$array_baidu_sitemap_options['it_is_update_sitemap_when_post']){$array_baidu_sitemap_options['it_is_update_sitemap_when_post'] = '1';}
		if(!$array_baidu_sitemap_options['it_post_limit']){$array_baidu_sitemap_options['it_post_limit'] = '1000';}
		if(!$array_baidu_sitemap_options['it_post_select']){$array_baidu_sitemap_options['it_post_select'] = '1';}
		if(!$array_baidu_sitemap_options['it_page_select']){$array_baidu_sitemap_options['it_page_select'] = '1';}
		if(!$array_baidu_sitemap_options['it_category_select']){$array_baidu_sitemap_options['it_category_select'] = '1';}
		if(!$array_baidu_sitemap_options['it_tag_select']){$array_baidu_sitemap_options['it_tag_select'] = '0';}
		if(!$array_baidu_sitemap_options['it_custom_post_select']){$array_baidu_sitemap_options['it_custom_post_select'] = '0';}
		if(!$array_baidu_sitemap_options['it_custom_category_select']){$array_baidu_sitemap_options['it_custom_category_select'] = '0';}
		if(!$array_baidu_sitemap_options['it_custom_post_noselect']){$array_baidu_sitemap_options['it_custom_post_noselect'] = '';}
		if(!$array_baidu_sitemap_options['it_custom_archives_select']){$array_baidu_sitemap_options['it_custom_archives_select'] = '';}
		if(!$array_baidu_sitemap_options['it_custom_archives_select0']){$array_baidu_sitemap_options['it_custom_archives_select0'] = '';}
		if(!$array_baidu_sitemap_options['it_custom_archives_name_select']){$array_baidu_sitemap_options['it_custom_archives_name_select'] = '';}
		if(!$array_baidu_sitemap_options['it_custom_archives_name_select0']){$array_baidu_sitemap_options['it_custom_archives_name_select0'] = '';}
		if(!$array_baidu_sitemap_options['it_custom_baidu_sutmit_token']){$array_baidu_sitemap_options['it_custom_baidu_sutmit_token'] = '';}
		if(!$array_baidu_sitemap_options['it_custom_baidu_sutmit_token_auto']){$array_baidu_sitemap_options['it_custom_baidu_sutmit_token_auto'] = '0';}
		if(!$array_baidu_sitemap_options['it_custom_baidu_sutmit_token_post_auto']){$array_baidu_sitemap_options['it_custom_baidu_sutmit_token_post_auto'] = '0';}
		if(!$array_baidu_sitemap_options['it_custom_baidu_sutmit_log']){$array_baidu_sitemap_options['it_custom_baidu_sutmit_log'] = '0';}
	}
	return $array_baidu_sitemap_options;
}

function baidu_sitemap_form(){
	$array_baidu_sitemap_options = get_baidu_sitemap_options();
?>
	<style>
		table{float:left;margin-right:80px;}
		.submit{clear:both;margin-top:0 !important;}
		.form2{float:left;margin:0 5px;}
	</style>
	<div class="postbox-container" style="width:75%;">
		<div class="metabox-holder">
			<div class="meta-box-sortables">	
				<div class="tool-box">
					<form name="baidu_sitemap_options" method="post" action="">
						<input type="hidden" name="action" value="build_options"/>
						<table>
							<tr><td><h3>基本配置</h3></td></tr>
							<tr><td>生成XML地图</td><td><input type="checkbox" name="it_is_Enabled_XML_Sitemap" value="1" <?php if($array_baidu_sitemap_options['it_is_Enabled_XML_Sitemap']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>生成Html地图</td><td><input type="checkbox" name="it_is_Enabled_Html_Sitemap" value="1" <?php if($array_baidu_sitemap_options['it_is_Enabled_Html_Sitemap']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>生成TXT地图</td><td><input type="checkbox" name="it_is_Enabled_TXT_Sitemap" value="1" <?php if($array_baidu_sitemap_options['it_is_Enabled_TXT_Sitemap']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>发布文章时自动更新</td><td><input type="checkbox" name="it_is_update_sitemap_when_post" value="1" <?php if($array_baidu_sitemap_options['it_is_update_sitemap_when_post']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>限制文章数量，最大99999</td><td><input type="number" step="1" min="1" max="99999" name="it_post_limit" maxlength="6" style="width:80px;" value="<?php $value = $array_baidu_sitemap_options['it_post_limit'];if($value){echo $value;}?>"></td></tr>
							<tr><td><h3>链接范围：</h3></td></tr>
							<tr><td>文章</td><td><input type="checkbox" name="it_post_select" value="1" <?php if($array_baidu_sitemap_options['it_post_select']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>页面</td><td><input type="checkbox" name="it_page_select" value="1" <?php if($array_baidu_sitemap_options['it_page_select']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>目录</td><td><input type="checkbox" name="it_category_select" value="1" <?php if($array_baidu_sitemap_options['it_category_select']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>标签</td><td><input type="checkbox" name="it_tag_select" value="1" <?php if($array_baidu_sitemap_options['it_tag_select']){echo 'checked="checked"';}?>/></td></tr>
						</table>
						<table>
							<tr><td><h3 style="color:red;">自定义类型文章、分类</h3></td></tr>
							<tr><td>文章</td><td><input type="checkbox" name="it_custom_post_select" value="1" <?php if($array_baidu_sitemap_options['it_custom_post_select']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>分类</td><td><input type="checkbox" name="it_custom_category_select" value="1" <?php if($array_baidu_sitemap_options['it_custom_category_select']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>排除自定义类型文章</td><td><input type="text" name="it_custom_post_noselect" style="width:80px;" value="<?php $value = $array_baidu_sitemap_options['it_custom_post_noselect'];if($value){echo $value;}?>"/></td></tr>
							<tr><td><h3 style="color:red;">自定义类型归档页：</h3></td></tr>
							<tr><td>url根字符串 | 栏目名</td><td><input type="text" name="it_custom_archives_select" style="width:80px;" value="<?php $value = $array_baidu_sitemap_options['it_custom_archives_select'];if($value){echo $value;}?>"/> | <input type="text" name="it_custom_archives_name_select" style="width:120px;" value="<?php $value = $array_baidu_sitemap_options['it_custom_archives_name_select'];if($value){echo $value;}?>"/></td></tr>
							<tr><td></td><td><input type="text" name="it_custom_archives_select0" style="width:80px;" value="<?php $value = $array_baidu_sitemap_options['it_custom_archives_select0'];if($value){echo $value;}?>"/> | <input type="text" name="it_custom_archives_name_select0" style="width:120px;" value="<?php $value = $array_baidu_sitemap_options['it_custom_archives_name_select0'];if($value){echo $value;}?>"/></td></tr>
						</table>
						<table>
							<tr><td><h3 style="color:red;">百度推送</h3></td></tr>
							<tr><td>api接口token</td><td><input type="text" name="it_custom_baidu_sutmit_token" value="<?php $value = $array_baidu_sitemap_options['it_custom_baidu_sutmit_token'];if($value){echo $value;}?>"/></td></tr>
							<tr><td>每日自动提交</td><td><input type="checkbox" name="it_custom_baidu_sutmit_token_auto" value="1" <?php if($array_baidu_sitemap_options['it_custom_baidu_sutmit_token_auto']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>发布文章时自动提交</td><td><input type="checkbox" name="it_custom_baidu_sutmit_token_post_auto" value="1" <?php if($array_baidu_sitemap_options['it_custom_baidu_sutmit_token_post_auto']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>提交日志</td><td><input type="checkbox" name="it_custom_baidu_sutmit_log" value="1" <?php if($array_baidu_sitemap_options['it_custom_baidu_sutmit_log']){echo 'checked="checked"';}?>/></td></tr>
							<tr><td>注：</td><td>已更新为立即生效</td></tr>
						</table>
						<p class="submit" style="border-top:1px solid red;"><input type="submit" class="button-primary" value="保存配置"/></p>
					</form>
				</div>
				<div class="tool-box">
					<h3 class="title">生成sitemap文件、百度api推送sitemap</h3>
					<form class="form2" name="baidu_sitemap_build" method="post" action="">
					<input type="hidden" name="action" value="build_xml"/>
					<p class="submit"><input type="submit" class="button-primary" value="生成sitemap文件"/></p>
					</form>
					<form class="form2" name="baidu_sitemap_submit" method="post" action="">
					<input type="hidden" name="action" value="baidu_submit_txt"/>
					<p class="submit"><input type="submit" class="button-primary" value="百度一键推送"/></p>
					</form>
				</div>
				<?php
				xml_file_exist();
				IT_rebuild_message();
				IT_rebuild_baidu_submit_message();
				?>
			</div>
		</div>
	</div>
	<?php
}

function baidu_sitemap_optionpage(){
	if(isset($_POST["action"])){
		if ($_POST["action"]=='build_options'){update_baidu_sitemap_options();}
		if ($_POST["action"]=='build_xml'){build_baidu_sitemap();}
		if ($_POST["action"]=='baidu_submit_txt'){baidu_sitemap_submit();}
	}
	echo '<div class="wrap"><div class="icon32"><br></div>';
	echo '<h2>Lsansan sitemap</h2>';
	echo '<p>这是一个用于生成网站sitemap文件的插件，功能简单，快捷好用。该插件偏向定制化，支持自定义文章类型、自定义分类等等</p>
	<p>Lsansan sitemap 的基本参数配置。心情好以后将会根据需要丰富选项。<span style="color:red;">Tips：如果 xml 和 html 都不勾选，千万不要点生成按钮哦！如果你要点，我也不拦着你^_^</span></p>';
	baidu_sitemap_form();
}

function update_baidu_sitemap_options(){
	if ($_POST['action']=='build_options'){

		$it_is_Enabled_XML_Sitemap = $_POST['it_is_Enabled_XML_Sitemap'];
		if(!$it_is_Enabled_XML_Sitemap){$it_is_Enabled_XML_Sitemap = 0;}
		$it_is_Enabled_Html_Sitemap = $_POST['it_is_Enabled_Html_Sitemap'];
		if(!$it_is_Enabled_Html_Sitemap){$it_is_Enabled_Html_Sitemap = 0;}
		$it_is_Enabled_TXT_Sitemap = $_POST['it_is_Enabled_TXT_Sitemap'];
		if(!$it_is_Enabled_TXT_Sitemap){$it_is_Enabled_TXT_Sitemap = 0;}
		$it_is_update_sitemap_when_post = $_POST['it_is_update_sitemap_when_post'];
		if(!$it_is_update_sitemap_when_post){$it_is_update_sitemap_when_post = 0;}
		$it_post_limit = $_POST['it_post_limit'];
		if(!$it_post_limit){$it_post_limit = 1000;}

		$it_post_select = $_POST['it_post_select'];
		if(!$it_post_select){$it_post_select = 0;}
		$it_page_select = $_POST['it_page_select'];
		if(!$it_page_select){$it_page_select = 0;}
		$it_category_select = $_POST['it_category_select'];
		if(!$it_category_select){$it_category_select = 0;}
		$it_tag_select = $_POST['it_tag_select'];
		if(!$it_tag_select){$it_tag_select = 0;}
		$it_custom_post_select = $_POST['it_custom_post_select'];
		if(!$it_custom_post_select){$it_custom_post_select = 0;}
		$it_custom_category_select = $_POST['it_custom_category_select'];
		if(!$it_custom_category_select){$it_custom_category_select = 0;}
		$it_custom_post_noselect = $_POST['it_custom_post_noselect'];
		if(!$it_custom_post_noselect){$it_custom_post_noselect = '';}
		$it_custom_archives_select = $_POST['it_custom_archives_select'];
		if(!$it_custom_archives_select){$it_custom_archives_select = '';}
		$it_custom_archives_select0 = $_POST['it_custom_archives_select0'];
		if(!$it_custom_archives_select0){$it_custom_archives_select0 = '';}
		$it_custom_archives_name_select = $_POST['it_custom_archives_name_select'];
		if(!$it_custom_archives_name_select){$it_custom_archives_name_select = '';}
		$it_custom_archives_name_select0 = $_POST['it_custom_archives_name_select0'];
		if(!$it_custom_archives_name_select0){$it_custom_archives_name_select0 = '';}
		$it_custom_baidu_sutmit_token = $_POST['it_custom_baidu_sutmit_token'];
		if(!$it_custom_baidu_sutmit_token){$it_custom_baidu_sutmit_token = '';}
		$it_custom_baidu_sutmit_token_auto = $_POST['it_custom_baidu_sutmit_token_auto'];
		if(!$it_custom_baidu_sutmit_token_auto){$it_custom_baidu_sutmit_token_auto = 0;}
		$it_custom_baidu_sutmit_token_post_auto = $_POST['it_custom_baidu_sutmit_token_post_auto'];
		if(!$it_custom_baidu_sutmit_token_post_auto){$it_custom_baidu_sutmit_token_post_auto = 0;}
		$it_custom_baidu_sutmit_log = $_POST['it_custom_baidu_sutmit_log'];
		if(!$it_custom_baidu_sutmit_log){$it_custom_baidu_sutmit_log = 0;}

		$baidu_sitemap_options = implode('|',array(
			$it_is_Enabled_XML_Sitemap,
			$it_is_Enabled_Html_Sitemap,
			$it_is_Enabled_TXT_Sitemap,
			$it_is_update_sitemap_when_post,
			$it_post_limit,
			$it_post_select,
			$it_page_select,
			$it_category_select,
			$it_tag_select,
			$it_custom_post_select,
			$it_custom_category_select,
			$it_custom_post_noselect,
			$it_custom_archives_select,
			$it_custom_archives_select0,
			$it_custom_archives_name_select,
			$it_custom_archives_name_select0,
			$it_custom_baidu_sutmit_token,
			$it_custom_baidu_sutmit_token_auto,
			$it_custom_baidu_sutmit_token_post_auto,
			$it_custom_baidu_sutmit_log,
		));
		update_option(NEW_BAIDU_SITEMAP_OPTION,$baidu_sitemap_options); 
        baidu_sitemap_topbarmessage('恭喜, 更新配置成功');
	}
}

function baidu_sitemap_submit($post_url = ''){
	$array_baidu_sitemap_options = get_baidu_sitemap_options();
	if($post_url){$submit_contents = $post_url;}
	else{$submit_contents = build_baidu_sitemap($submit = 1);}
	if($submit_contents){
		$urls = $submit_contents;
		$api = 'http://data.zz.baidu.com/urls?site='.home_url().'&token='.$array_baidu_sitemap_options['it_custom_baidu_sutmit_token'];
		$ch = curl_init();
		if(!$post_url){$urls = implode("\n", $urls);}
		$options =  array(
			CURLOPT_URL => $api,
			CURLOPT_POST => true,
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_POSTFIELDS => $urls,
			CURLOPT_HTTPHEADER => array('Content-Type: text/plain'),
		);
		curl_setopt_array($ch, $options);
		$result = curl_exec($ch);$result1 = json_decode($result);$logs = '';
		$error = '推送失败，错误代码：'.$result1->message;
		$success = '推送成功：'.$result1->success.'条，当天剩余推送条数：'.$result1->remain;
		if(!$post_url){
			if($result1->error){baidu_sitemap_topbarmessage($error);$logs = $error;}
			elseif($result1->success){baidu_sitemap_topbarmessage($success);$logs = $success;}
			if($logs && $array_baidu_sitemap_options['it_custom_baidu_sutmit_log'] == 1){file_put_contents_checks('log',date("Y年m月d日 H:i:s",time())." ".$logs."\r\n",FILE_APPEND);}
		}
		else{
			if($result1->error){$logs = $error;}
			elseif($result1->success){$logs = $success;}
			if($logs && $array_baidu_sitemap_options['it_custom_baidu_sutmit_log'] == 1){file_put_contents_checks('log',date("Y年m月d日 H:i:s",time())." ".$logs." url：".$urls." "."\r\n",FILE_APPEND);}
			return $logs;
		}
	}
}

add_filter('post_updated_messages', 'my_post_updated_messages_filter',1); 
function my_post_updated_messages_filter($messages){
	$array_baidu_sitemap_options = get_baidu_sitemap_options();
	$message_this = substr($_SERVER['REQUEST_URI'],strripos($_SERVER['REQUEST_URI'],"message=")+8);
	if($array_baidu_sitemap_options['it_custom_baidu_sutmit_token_post_auto'] == 1 && $message_this == 6){
		global $post;
		$submit_massges = baidu_sitemap_submit(get_permalink($post->ID));
		$messages['post'][6] = '文章已发布, <a href="'.get_permalink($post->ID).'">查看文章</a>。'.$submit_massges;
	}
	return $messages;
}

function build_baidu_sitemap($submit = ''){
    global $wpdb, $posts;
	$submit_contents = array();
	array_push($submit_contents,home_url());
	$array_baidu_sitemap_options = get_baidu_sitemap_options();
	if(!$array_baidu_sitemap_options['it_post_limit']){$it_limit = '1000';}else{$it_limit = $array_baidu_sitemap_options['it_post_limit'];}
	$sql_mini = "select ID,post_modified,post_date,post_type FROM $wpdb->posts
	        WHERE post_password = ''
			AND post_type <> 'nav_menu_item'
			AND post_status = 'publish'
			ORDER BY post_modified DESC
			LIMIT 0,$it_limit
	       ";
	$recentposts_mini = $wpdb->get_results($sql_mini);
	if($recentposts_mini){
		foreach ($recentposts_mini as $post){
			if($post->post_type == 'page'){
				if(!$array_baidu_sitemap_options['it_page_select']){continue;}
				$loc = get_page_link($post->ID);
				$loc = IT_EscapeXML($loc);
				if(!$loc){continue;}
				if($post->post_modified == '0000-00-00 00:00:00'){$post_date = $post->post_date;} else {$post_date = $post->post_modified;} 
				$lastmod = date("Y-m-d\TH:i:s+00:00",IT_GetTimestampFromMySql($post_date));
				$changefreq = 'Weekly';
				$priority = '0.6';
				$xml_contents_page .= "<url>";
				$xml_contents_page .= "<loc>$loc</loc>";
				$txt_contents_page .= "$loc\r\n";array_push($submit_contents,$loc);
				$xml_contents_page .= "<lastmod>$lastmod</lastmod>";
				$xml_contents_page .= "<changefreq>$changefreq</changefreq>";
				$xml_contents_page .= "<priority>$priority</priority>";
				$xml_contents_page .= "</url>";
			}
			elseif($post->post_type == 'post'){
				if(!$array_baidu_sitemap_options['it_post_select']){continue;}
				$wp_query_post = new WP_Query(array('p'=>$post->ID));
				if($wp_query_post->have_posts()){while($wp_query_post->have_posts()){$wp_query_post->the_post();}}
				$loc = get_permalink($post->ID);
				$loc = IT_EscapeXML($loc);
				if(!$loc){continue;}
				if($post->post_modified == '0000-00-00 00:00:00'){$post_date = $post->post_date;} else {$post_date = $post->post_modified;}
				$lastmod = date("Y-m-d\TH:i:s+00:00",IT_GetTimestampFromMySql($post_date));
				$changefreq = 'monthly';
				$priority = '1';
				$xml_contents_post .= "<url>";
				$xml_contents_post .= "<loc>$loc</loc>";
				$txt_contents_post .= "$loc\r\n";array_push($submit_contents,$loc);
				$xml_contents_post .= "<lastmod>$lastmod</lastmod>";
				$xml_contents_post .= "<changefreq>$changefreq</changefreq>";
				$xml_contents_post .= "<priority>$priority</priority>";
				$xml_contents_post .= "</url>";
				wp_reset_postdata();
			}
			elseif($post->post_type != $array_baidu_sitemap_options['it_custom_post_noselect']){
				if(!$array_baidu_sitemap_options['it_custom_post_select']){continue;}
				$loc = get_permalink($post->ID);
				$loc = IT_EscapeXML($loc);
				if(!$loc){continue;}
				if($post->post_modified == '0000-00-00 00:00:00'){$post_date = $post->post_date;} else {$post_date = $post->post_modified;}
				$lastmod = date("Y-m-d\TH:i:s+00:00",IT_GetTimestampFromMySql($post_date));
				$changefreq = 'monthly';
				$priority = '1';
				$xml_contents_custom_post .= "<url>";
				$xml_contents_custom_post .= "<loc>$loc</loc>";
				$txt_contents_custom_post .= "$loc\r\n";array_push($submit_contents,$loc);
				$xml_contents_custom_post .= "<lastmod>$lastmod</lastmod>";
				$xml_contents_custom_post .= "<changefreq>$changefreq</changefreq>";
				$xml_contents_custom_post .= "<priority>$priority</priority>";
				$xml_contents_custom_post .= "</url>";
			}
		}
		if($array_baidu_sitemap_options['it_category_select']){
			$category_ids = get_terms(array('taxonomy'=>'category','hide_empty'=>0));/*get_all_category_ids();*/
			if($category_ids){
				foreach($category_ids as $cat_id){
					$loc = get_category_link($cat_id->term_id);/*$cat_id*/
					$loc = IT_EscapeXML($loc);
					$loc = str_replace("/./","/",$loc);
					if(!$loc){continue;}
					$lastmod = date("Y-m-d\TH:i:s+00:00",current_time('timestamp', '1'));
					$changefreq = 'Weekly';
					$priority = '0.8';
					$xml_contents_cat .= "<url>";
					$xml_contents_cat .= "<loc>$loc</loc>";
					$txt_contents_cat .= "$loc\r\n";array_push($submit_contents,$loc);
					$xml_contents_cat .= "<lastmod>$lastmod</lastmod>";
					$xml_contents_cat .= "<changefreq>$changefreq</changefreq>";
					$xml_contents_cat .= "<priority>$priority</priority>";
					$xml_contents_cat .= "</url>";
				}
			}
		}
		if($array_baidu_sitemap_options['it_custom_category_select']){
			$sql_html0 = "select term_taxonomy_id FROM wp_term_taxonomy
				WHERE taxonomy NOT IN('category','nav_menu','post_tag')
				ORDER BY term_taxonomy_id ASC
			   ";
			$custom_category_html = $wpdb->get_results($sql_html0);
			if($custom_category_html){
				foreach ($custom_category_html as $terms){
					$loc = get_category_link($terms->term_taxonomy_id);
					$loc = IT_EscapeXML($loc);
					if(!$loc){continue;}
					$lastmod = date("Y-m-d\TH:i:s+00:00",current_time('timestamp', '1'));
					$changefreq = 'Weekly';
					$priority = '0.8';
					$xml_contents_custom_cat .= "<url>";
					$xml_contents_custom_cat .= "<loc>$loc</loc>";
					$txt_contents_custom_cat .= "$loc\r\n";array_push($submit_contents,$loc);
					$xml_contents_custom_cat .= "<lastmod>$lastmod</lastmod>";
					$xml_contents_custom_cat .= "<changefreq>$changefreq</changefreq>";
					$xml_contents_custom_cat .= "<priority>$priority</priority>";
					$xml_contents_custom_cat .= "</url>";
				}
			}
		}
		for($i=0;$i<3;$i++){
			$k = $i == 0 ? '' : $i-1;$i+1;
			$it_custom_archives_select = 'it_custom_archives_select'.$k;
			$it_custom_archives_name_select = 'it_custom_archives_name_select'.$k;
			if($array_baidu_sitemap_options[$it_custom_archives_select] && $array_baidu_sitemap_options[$it_custom_archives_name_select]){
				$loc = get_bloginfo('url').'/'.$array_baidu_sitemap_options[$it_custom_archives_select];
				$loc = IT_EscapeXML($loc);
				$lastmod = date("Y-m-d\TH:i:s+00:00",current_time('timestamp', '1'));
				$changefreq = 'Weekly';
				$priority = '0.8';
				$xml_contents_custom_archives .= "<url>";
				$xml_contents_custom_archives .= "<loc>$loc</loc>";
				$txt_contents_custom_archives .= "$loc\r\n";array_push($submit_contents,$loc);
				$xml_contents_custom_archives .= "<lastmod>$lastmod</lastmod>";
				$xml_contents_custom_archives .= "<changefreq>$changefreq</changefreq>";
				$xml_contents_custom_archives .= "<priority>$priority</priority>";
				$xml_contents_custom_archives .= "</url>";
			}
		}
		if($array_baidu_sitemap_options['it_tag_select']){
			$all_the_tags = get_tags();
			if($all_the_tags){
				foreach($all_the_tags as $this_tag){
					$tag_id = $this_tag->term_id;
					$loc = get_tag_link($tag_id);
					$loc = IT_EscapeXML($loc);
					if(!$loc){continue;}
					$lastmod = date("Y-m-d\TH:i:s+00:00",current_time('timestamp', '1'));
					$changefreq = 'Weekly';
					$priority = '0.8';
					$xml_contents_tag .= "<url>";
					$xml_contents_tag .= "<loc>$loc</loc>";
					$txt_contents_tag .= "$loc\r\n";array_push($submit_contents,$loc);
					$xml_contents_tag .= "<lastmod>$lastmod</lastmod>";
					$xml_contents_tag .= "<changefreq>$changefreq</changefreq>";
					$xml_contents_tag .= "<priority>$priority</priority>";
					$xml_contents_tag .= "</url>";
				}
			}
		}
		$xml_contents = $xml_contents_page.$xml_contents_cat.$xml_contents_custom_cat.$xml_contents_custom_archives.$xml_contents_post.$xml_contents_custom_post.$xml_contents_tag;
		$txt_contents = $txt_contents_page.$txt_contents_cat.$txt_contents_custom_cat.$txt_contents_custom_archives.$txt_contents_post.$txt_contents_custom_post.$txt_contents_tag;
		if($submit){return $submit_contents;}
	}
	if($array_baidu_sitemap_options['it_is_Enabled_XML_Sitemap']){build_baidu_sitemap_xml($xml_contents);}
	if($array_baidu_sitemap_options['it_is_Enabled_Html_Sitemap']){build_baidu_sitemap_html();}
	if($array_baidu_sitemap_options['it_is_Enabled_TXT_Sitemap']){build_baidu_sitemap_txt($txt_contents);}
	if(!$array_baidu_sitemap_options['it_is_Enabled_XML_Sitemap'] && !$array_baidu_sitemap_options['it_is_Enabled_Html_Sitemap'] && !$array_baidu_sitemap_options['it_is_Enabled_TXT_Sitemap']){
		baidu_sitemap_topbarmessage('兄弟,你是来搞笑的吗？你啥都不生成，点个生成要生成个啥？');
	}//此处添加自动推送百度代码
}

function build_baidu_sitemap_xml($xml_contents){
	$array_baidu_sitemap_options = get_baidu_sitemap_options();
	$it_blog_url = home_url();
	$blogtime = current_time('timestamp', '1');
	$it_blog_time = date("Y-m-d\TH:i:s+00:00",$blogtime);
	$xml_begin = '<?xml version="1.0" encoding="UTF-8"?>'.xml_annotate().'<urlset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd" xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
	$xml_home = "<url><loc>$it_blog_url</loc><lastmod>$it_blog_time</lastmod><changefreq>daily</changefreq><priority>1.0</priority></url>";
	$xml_end = '</urlset>';
	if($xml_contents){
		$baidu_xml = $xml_begin.$xml_home.$xml_contents.$xml_end;
		file_put_contents_checks('xml',$baidu_xml);
	}
}
function build_baidu_sitemap_txt($txt_contents){
	$it_blog_url = home_url();
	$txt_home = "$it_blog_url\r\n";
	if($txt_contents){
		$baidu_txt = $txt_home.$txt_contents;
		file_put_contents_checks('txt',$baidu_txt);
	}
}

function build_baidu_sitemap_html(){
	global $wpdb;
	$array_baidu_sitemap_options = get_baidu_sitemap_options();
	$blogtime = current_time('mysql');
	list($today_year, $today_month, $today_day, $hour, $minute, $second) = preg_split('([^0-9])', $blogtime);
	$html_post_contents = '';
	if($array_baidu_sitemap_options['it_post_select']){
		$sql_html1 = "select ID FROM $wpdb->posts
	        WHERE post_password = ''
			AND post_type='post'
			AND post_status = 'publish'
			ORDER BY post_modified,post_type DESC
			LIMIT 0,2000
	       ";
		$recentposts_html1 = $wpdb->get_results($sql_html1);
		if($recentposts_html1){
			foreach ($recentposts_html1 as $post){
				$wp_query_post = new WP_Query(array('p'=>$post->ID));
				if($wp_query_post->have_posts()){while($wp_query_post->have_posts()){$wp_query_post->the_post();}}
				$html_post_contents .= '<li><a href="'.get_permalink($post->ID).'" title="'.get_the_title($post->ID).'" target="_blank">'.get_the_title($post->ID).'</a></li>';
				wp_reset_postdata();
			}
		}
	}
    if($array_baidu_sitemap_options['it_category_select']){
		$html_category_contents = wp_list_categories(array('echo'=>0,'hide_empty'=>0));
	}
	if($array_baidu_sitemap_options['it_page_select']){
		$html_page_contents = wp_list_pages(array('echo'=>0,'hide_empty'=>0));
	}
	if($array_baidu_sitemap_options['it_tag_select']){
		$html_tag_contents = wp_tag_cloud('echo=0&number=245');
		$html_tag_contents = '<br><h3>标签</h3>'.$html_tag_contents;
	}
	$html_custom_post_contents = '';
	if($array_baidu_sitemap_options['it_custom_post_select']){
		$sql_html2 = "select ID FROM $wpdb->posts
	        WHERE post_password = ''
			AND post_type NOT IN('post','page','nav_menu_item','".$array_baidu_sitemap_options['it_custom_post_noselect']."')
			AND post_status = 'publish'
			ORDER BY post_modified DESC
			LIMIT 0,2000
	       ";
		$custom_post_html = $wpdb->get_results($sql_html2);
		if($custom_post_html){
			foreach ($custom_post_html as $custom_post){
				$html_custom_post_contents .= '<li><a href="'.get_permalink($custom_post->ID).'" title="'.get_the_title($custom_post->ID).'" target="_blank">'.get_the_title($custom_post->ID).'</a></li>';
			}
		}
	}
	$html_custom_category_contents = '';
	if($array_baidu_sitemap_options['it_custom_category_select']){
		$html_custom_category_contents = '<li class="custom_category">自定义分类<ul>';
		
		$sql_html3 = "select a.term_taxonomy_id,b.name FROM wp_term_taxonomy as a,wp_terms as b
			WHERE a.term_taxonomy_id = b.term_id
			AND a.taxonomy NOT IN('category','nav_menu','post_tag')
			ORDER BY a.term_taxonomy_id ASC
	       ";
		$custom_category_html = $wpdb->get_results($sql_html3);
		if($custom_category_html){
			foreach ($custom_category_html as $terms){
				$html_custom_category_contents .= '<li><a href="'.get_category_link($terms->term_taxonomy_id).'" title="'.$terms->name.'" target="_blank">'.$terms->name.'</a></li>';
			}
		}
		$html_custom_category_contents .= '</ul></li><li class="custom_category">自定义类型归档页<ul>';
	}
	for($i=0;$i<3;$i++){
		$k = $i == 0 ? '' : $i-1;$i+1;
		$it_custom_archives_select = 'it_custom_archives_select'.$k;
		$it_custom_archives_name_select = 'it_custom_archives_name_select'.$k;
		if($array_baidu_sitemap_options[$it_custom_archives_select] && $array_baidu_sitemap_options[$it_custom_archives_name_select]){
			$html_custom_category_contents .= '<li><a href="'.get_bloginfo('url').'/'.$array_baidu_sitemap_options[$it_custom_archives_select].'" title="'.$array_baidu_sitemap_options[$it_custom_archives_name_select].'" target="_blank">'.$array_baidu_sitemap_options[$it_custom_archives_name_select].'</a></li>';
		}
	}
	$html_custom_category_contents .= '</ul></li>';
	$blog_title = 'sitemap';
	$blog_name = get_bloginfo('name'); 
	$blog_keywords = $blog_title.','.$blog_name;
	$it_generator = 'Lsansan sitemap';
	$it_author = 'Lsansan';
	$it_copyright = 'Lsansan';
	$blog_home = get_bloginfo('url');
	$sitemap_url = get_bloginfo('url').'/sitemap.html';
	$xml_url = get_bloginfo('url').'/sitemap.xml';
	$updated_time = "$today_year-$today_month-$today_day $hour:$minute:$second";
	if($html_post_contents || $html_custom_post_contents){
		$path_html  = IT_GetPluginPath().'sitemap.html';
		$html = file_get_contents("$path_html");
		$html = str_replace("%blog_title%",$blog_title,$html);
		$html = str_replace("%blog_name%",$blog_name,$html);
		$html = str_replace("%blog_home%",$blog_home,$html);
		$html = str_replace("%blog_keywords%",$blog_keywords,$html);
		$html = str_replace("%it_generator%",$it_generator,$html);
		$html = str_replace("%it_author%",$it_author,$html);
		$html = str_replace("%it_copyright%",$it_copyright,$html);
		$html = str_replace("%sitemap_url%",$sitemap_url,$html);
		$html = str_replace("%blog_sitemap%",$xml_url,$html);
		$html = str_replace("%updated_time%",$updated_time,$html);
		$html = str_replace("%it_post_contents%",$html_post_contents,$html);		
		$html = str_replace("%it_category_contents%",$html_category_contents,$html);
		$html = str_replace("%it_page_contents%",$html_page_contents,$html);
		$html = str_replace("%it_tag_contents%",$html_tag_contents,$html);
		$html = str_replace("%it_custom_post_contents%",$html_custom_post_contents,$html);
		$html = str_replace("%html_custom_category_contents%",$html_custom_category_contents,$html);
		file_put_contents_checks('html',$html);
	}
}

function file_put_contents_checks($filename,$html,$flags = ''){
	$IT_GetHomePath = IT_GetHomePath();
	$file_name = $IT_GetHomePath.'sitemap.'.$filename;
	if(IT_IsFileWritable($IT_GetHomePath) || IT_IsFileWritable($file_name)){
		if($flags){file_put_contents("$file_name","$html","$flags");}
		else{file_put_contents("$file_name","$html");}
		chmod($file_name, 0777);
		baidu_sitemap_topbarmessage('恭喜, 生成 sitemap.'.$filename.' 文件成功');
	}
	else{
		baidu_sitemap_topbarmessage('文件或目录不可写，请修改目录权限改为777。');
	}
}

function baidu_sitemap_topbarmessage($msg){echo '<div class="updated fade" id="message"><p>'.$msg.'</p></div>';}

//自动化
function baidu_sitemap_is_auto_daily(){
	$only_this_one = get_baidu_sitemap_options();
	if(!wp_next_scheduled('do_baidu_sitemap_auto_daily')){
		if($only_this_one['it_is_Enabled_XML_Sitemap'] || $only_this_one['it_is_Enabled_Html_Sitemap'] || $only_this_one['it_is_Enabled_TXT_Sitemap']){
			wp_schedule_event(time()+15,'daily','do_baidu_sitemap_auto_daily');
		}
	}
	else{
		if(!$only_this_one['it_is_Enabled_XML_Sitemap'] && !$only_this_one['it_is_Enabled_Html_Sitemap'] && !$only_this_one['it_is_Enabled_TXT_Sitemap']){
			wp_clear_scheduled_hook('do_baidu_sitemap_auto_daily');
		}
	}
}
add_action('do_baidu_sitemap_auto_daily','build_baidu_sitemap');

function baidu_submit_sitemap_is_auto_daily(){
	$only_this_one = get_baidu_sitemap_options();
	if(!wp_next_scheduled('do_baidu_submit_sitemap_auto_daily')){
		if($only_this_one['it_custom_baidu_sutmit_token_auto']){
			wp_schedule_event(time()+15,'daily','do_baidu_submit_sitemap_auto_daily');
		}
	}
	else{
		if(!$only_this_one['it_custom_baidu_sutmit_token_auto']){
			wp_clear_scheduled_hook('do_baidu_submit_sitemap_auto_daily');
		}
	}
}
add_action('do_baidu_submit_sitemap_auto_daily','baidu_sitemap_submit');
//自动化end
function baidu_sitemap_by_post($post_ID){
	$get_baidu_sitemap_options = get_option(NEW_BAIDU_SITEMAP_OPTION);
	if(isset($get_baidu_sitemap_options['it_is_update_sitemap_when_post'])){
		if($get_baidu_sitemap_options['it_is_update_sitemap_when_post'] == '1'){
			build_baidu_sitemap();
		}
	}
	return $post_ID;
}
add_action('publish_post', 'baidu_sitemap_by_post');
add_action('save_post', 'baidu_sitemap_by_post');
add_action('edit_post', 'baidu_sitemap_by_post');
add_action('delete_post', 'baidu_sitemap_by_post');
add_action('admin_menu',function(){if(current_user_can('manage_options'))add_options_page('Lsansan sitemap','Lsansan sitemap',8, __FILE__,'baidu_sitemap_optionpage');});
?>